// ControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EX4.h"
#include "ControlDlg.h"
#include "EX4Dlg.h"
#include "mm.h"

// CControlDlg dialog

IMPLEMENT_DYNAMIC(CControlDlg, CDialog)

CControlDlg::CControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CControlDlg::IDD, pParent)
{

}

CControlDlg::~CControlDlg()
{
}

void CControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_RWHEEL, _rwheelSliderCtrl);	
	DDX_Control(pDX, IDC_SLIDER_LWHEEL, _lwheelSliderCtrl);	
	DDX_Text(pDX, IDC_EDIT_RWHEEL, _editRwheel);
	DDX_Text(pDX, IDC_EDIT_LWHEEL, _editLwheel);
	DDX_Text(pDX, IDC_EDIT_LOCATION_X, _editLocationX);
	DDX_Text(pDX, IDC_EDIT_LOCATION_Y, _editLocationY);
	DDX_Text(pDX, IDC_EDIT_LOCATION_Z, _editLocationZ);
	DDX_Text(pDX, IDC_EDIT_DISTANCE1, _editDistance1);
	DDX_Text(pDX, IDC_EDIT_DISTANCE2, _editDistance2);
	DDX_Text(pDX, IDC_EDIT_LANGLE, _editLangle);
	DDX_Text(pDX, IDC_EDIT_RANGLE, _editRangle);
	DDX_Text(pDX, IDC_EDIT_TOUCH, _editTouch);
	DDX_Text(pDX, IDC_EDIT_LASER, _editLaser);
}


BEGIN_MESSAGE_MAP(CControlDlg, CDialog)
	ON_WM_HSCROLL()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CControlDlg message handlers

BOOL CControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	_rwheelSliderCtrl.SetRange(-360, 360, true);
	_rwheelSliderCtrl.SetPos(0);
	_lwheelSliderCtrl.SetRange(-360, 360, true);
	_lwheelSliderCtrl.SetPos(0);

	_editRwheel.Format("%d", 0);
	_editLwheel.Format("%d", 0);

	_editLocationX.Format("%f", 0.);
	_editLocationY.Format("%f", 0.);
	_editLocationZ.Format("%f", 0.);

	_editDistance1.Format("%f", 0.);
	_editDistance2.Format("%f", 0.);

	_editLangle.Format("%f", 0.);
	_editRangle.Format("%f", 0.);

	SetTimer (1002, 100, NULL);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CControlDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CEX4Dlg* _pDlg = (CEX4Dlg*)::AfxGetMainWnd();
	
	_editLwheel.Format("%d deg/s", _lwheelSliderCtrl.GetPos());
	_pDlg->_ode->SetJointVelocity("LWHEEL_JOINT", 0, _DEG2RAD*_lwheelSliderCtrl.GetPos());

	_editRwheel.Format("%d deg/s", _rwheelSliderCtrl.GetPos());
	_pDlg->_ode->SetJointVelocity("RWHEEL_JOINT", 0, _DEG2RAD*_rwheelSliderCtrl.GetPos());

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CControlDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1002) {
		CEX4Dlg* _pDlg = (CEX4Dlg*)::AfxGetMainWnd();

		_editLangle.Format("%5.0f deg", _RAD2DEG*_pDlg->_ode->GetJointAngle("LWHEEL_JOINT"));
		_editRangle.Format("%5.0f deg", _RAD2DEG*_pDlg->_ode->GetJointAngle("RWHEEL_JOINT"));

		double x, y, z;
		_pDlg->_ode->GetLocation("LOCATION", x, y, z);
		
		_editLocationX.Format("%5.3f m", x);
		_editLocationY.Format("%5.3f m", y);
		_editLocationZ.Format("%5.3f m", z);	
		
		_editDistance1.Format("%5.3f m", _pDlg->_ode->GetDistance("LEFT_DIST"));
		_editDistance2.Format("%5.3f m", _pDlg->_ode->GetDistance("RIGHT_DIST"));

		bool touch = _pDlg->_ode->GetTouch("TOUCH");
		_editTouch.Format(touch ? "true" : "false");

		// Scanning laser range sensor
		_editLaser = "";			
		for (int ang=-90, c=1; ang<=90; ang+=5, c++) {
			char name[64];
			sprintf (name, "LASER%d", ang);

			_editLaser.AppendFormat ("%8.4f,", _pDlg->_ode->GetDistance(name));
			if (c%5==0) _editLaser.AppendFormat ("\r\n");
		}		

		UpdateData(FALSE);
	}
	CDialog::OnTimer(nIDEvent);
}
