
// EX4Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EX4.h"
#include "EX4Dlg.h"
#include "mm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CEX4Dlg dialog
CEX4Dlg::CEX4Dlg(CWnd* pParent /*=NULL*/)
: CDialog(CEX4Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_ode = NULL;
	_ogl = NULL;

	_ctrlDlg = NULL;
}

void CEX4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CEX4Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CTRL, &CEX4Dlg::OnBnClickedButtonCtrl)
END_MESSAGE_MAP()


BOOL CEX4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// OpenGL ׸ ȭ ũ⸦ ´.
	// ⼭ Ŭ̾Ʈ   ư ִ    ´.
	CRect rect;
	GetClientRect(rect);
	rect.top += 40;

	// ODE ü Ѵ.
	_ode = new COde ();

	// Sensor :
	// 1. Sensor  Ʈ .
	// 2. Body Sensor  (SetRigidBody)
	// 3. Ʈ ϴ Senser Ư οѴ.

	// 
	_ode->AddBox		("WALL",		100,  RGB(127, 127, 127),		1,     0,     0.5,		_DEG2RAD*0,  _DEG2RAD*0, _DEG2RAD*0,	0.2, 1, 1);

	// mobile robot 
	_ode->AddBox		("BODY",		30,  RGB(127, 127, 127),		0,     0,     0.12,		_DEG2RAD*0,  _DEG2RAD*0,	_DEG2RAD*0,	0.3, 0.3, 0.08);
	_ode->AddCylinder	("LEFT_WHEEL",	1,   RGB(255, 255, 255),		0.05,  0.18,  0.06,		_DEG2RAD*90, _DEG2RAD*0,	_DEG2RAD*0,	0.06, 0.03);
	_ode->AddCylinder	("RIGHT_WHEEL",	1,   RGB(255, 255, 255),		0.05, -0.18,  0.06,		_DEG2RAD*90, _DEG2RAD*0,	_DEG2RAD*0,	0.06, 0.03);
	_ode->AddBox		("CASTER_P",	0.5, RGB(255, 255, 127),		-0.16,  0.,    0.07,	_DEG2RAD*0,  _DEG2RAD*0,	_DEG2RAD*0,	0.05, 0.03, 0.01);
	_ode->AddCylinder	("CASTER",		0.5, RGB(255, 255, 255),		-0.18,  0.,    0.03,	_DEG2RAD*90, _DEG2RAD*0,	_DEG2RAD*0,	0.03, 0.01);

	// Mobile robot Joint 
	_ode->AttachHingeJoint	("LWHEEL_JOINT", "BODY", "LEFT_WHEEL",		0., -1., 0., 	0.05,  0.18,  0.06,	100);
	_ode->AttachHingeJoint	("RWHEEL_JOINT", "BODY", "RIGHT_WHEEL",		0., -1., 0.,	0.05,  -0.18, 0.06,	100);
	_ode->AttachHingeJoint	("CAST_JOINT1", "BODY", "CASTER_P",			0., 0., 1.,		-0.14, 0.,    0.07,	0);
	_ode->AttachHingeJoint	("CAST_JOINT2", "CASTER_P", "CASTER",		0., 1., 0.,		-0.18, 0.,    0.03,	0);

	// Sensor Ư ο Ʈ 
	_ode->AddBox		("LOCATION",	0.0001,	RGB(255, 127, 127),		0,     0,     0.18,     _DEG2RAD*0,	_DEG2RAD*0,   _DEG2RAD*0,  0.03, 0.03, 0.03);
	_ode->AddBox		("TOUCH",		0.0001, RGB(127, 255, 127),		-0.15, 0,     0.12,		_DEG2RAD*0,  _DEG2RAD*0,   _DEG2RAD*0,  0.03, 0.03, 0.01);
	_ode->AddRay		("LEFT_DIST",	        RGB(255, 0, 127),		-0.1,  0.16,  0.1,		_DEG2RAD*90,  _DEG2RAD*0, _DEG2RAD*0,	0.8);
	_ode->AddRay		("RIGHT_DIST",	        RGB(255, 0, 127),		-0.1, -0.16,  0.1,		_DEG2RAD*-90, _DEG2RAD*0, _DEG2RAD*0,	0.8);

	// Ʈ Sensor Ư ο
	_ode->SetLocationSensor ("LOCATION", "BODY");
	_ode->SetTouchSensor	("TOUCH", "BODY");
	// Distance  ׻ ray Ʈ ؾ Ѵ.
	_ode->SetDistanceSensor ("LEFT_DIST", "BODY", 0.8);
	_ode->SetDistanceSensor ("RIGHT_DIST", "BODY", 0.8);

	// Scanning laser range sensor
	for (int ang=-90; ang<=90; ang+=5) {
		char name[64];
		sprintf (name, "LASER%d", ang);

		_ode->AddRay	(name,	                RGB(255, 0, 127),		 0.16, 0.0,  0.1,		_DEG2RAD*-90, _DEG2RAD*(-90-ang), _DEG2RAD*0,	1.0);
		_ode->SetDistanceSensor (name, "BODY", 4.1);
	}


	// ODE ׸  OpenGL ü Ѵ.
	_ogl = new COdeOgl(_ode, "ODE", rect, this, 90000);
	_ogl->_showAxis = false;

	SetTimer (1000, 10, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEX4Dlg::OnPaint()
{
	if (IsIconic()) 
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEX4Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CEX4Dlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	//   ũⰡ ٲ , OpenGL  ũ⸦ Ѵ.
	if (_ogl) {
		_ogl->MoveWindow (0, 40, cx, cy-40);
	}
}

void CEX4Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(_ctrlDlg) {
		_ctrlDlg->DestroyWindow ();
		delete _ctrlDlg;
	}

	_ogl->DestroyWindow ();
	delete _ogl;

	delete _ode;
}


void CEX4Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// ODE ùķ̼   Ѵ.
	_ode->Step (0.01);
	// ùķ̼  OpenGL 쿡 Ʈ Ѵ.
	_ogl->UpdateWnd ();

	CDialog::OnTimer(nIDEvent);
}

void CEX4Dlg::OnBnClickedButtonCtrl()
{
	if(_ctrlDlg != NULL) {
		_ctrlDlg->SetFocus();
		_ctrlDlg->ShowWindow(SW_SHOW);
	}
	else {
		_ctrlDlg = new CControlDlg;
		_ctrlDlg->Create(IDD_DIALOG_CONTROL, this);
		_ctrlDlg->ShowWindow(SW_SHOW);	
	}	
}
